"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var init_1 = require("./init");
var message_event_channel_1 = require("message-event-channel");
var ExtensionFactory_1 = require("./extensions/ExtensionFactory");
var Errors_1 = require("./constants/Errors");
jest.mock('message-event-channel');
jest.mock('./extensions/ExtensionFactory');
describe('init', function () {
    var mockedConnection = {
        init: jest.fn(),
        on: jest.fn(),
        request: jest.fn(),
    };
    beforeAll(function () {
        message_event_channel_1.ClientConnection.mockImplementation(function () {
            return mockedConnection;
        });
    });
    beforeEach(function () { return jest.clearAllMocks(); });
    it('should return a promise', function () {
        var sdk = init_1.init();
        expect(sdk instanceof Promise).toBeTruthy();
    });
    it('should reject the promise when it times out', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockedConnection.on.mockImplementation(function (event, handler) {
                        if (event === message_event_channel_1.MC_EVENTS.CONNECTION_TIMEOUT) {
                            handler();
                        }
                    });
                    return [4 /*yield*/, expect(init_1.init()).rejects.toThrowErrorMatchingInlineSnapshot("\"Failed to establish connection to DC Application\"")];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to accept no options and use defaults', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockedConnection.on.mockImplementation(function (event, handler) {
                        if (event === message_event_channel_1.MC_EVENTS.CONNECTION_TIMEOUT) {
                            handler();
                        }
                    });
                    return [4 /*yield*/, expect(init_1.init()).rejects.toBeTruthy()];
                case 1:
                    _a.sent();
                    expect(message_event_channel_1.ClientConnection).toHaveBeenCalledWith({
                        window: window,
                        connectionTimeout: false,
                        timeout: false,
                        debug: false,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to accept options', function () { return __awaiter(void 0, void 0, void 0, function () {
        var options;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockedConnection.on.mockImplementation(function (event, handler) {
                        if (event === message_event_channel_1.MC_EVENTS.CONNECTION_TIMEOUT) {
                            handler();
                        }
                    });
                    options = {
                        window: {},
                        connectionTimeout: 1,
                        timeout: 2,
                        debug: true,
                    };
                    return [4 /*yield*/, expect(init_1.init(options)).rejects.toBeTruthy()];
                case 1:
                    _a.sent();
                    expect(message_event_channel_1.ClientConnection).toHaveBeenCalledWith(options);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should reject if it fails to retrieve the context object fails', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockedConnection.on.mockImplementation(function (event, handler) {
                        if (event === message_event_channel_1.MC_EVENTS.CONNECTED) {
                            handler();
                        }
                    });
                    mockedConnection.request.mockRejectedValue(new Error('Test'));
                    return [4 /*yield*/, expect(init_1.init()).rejects.toThrowErrorMatchingInlineSnapshot("\"Failed to fetch context for UI Extension\"")];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should reject if the call to extensionFactory() fails', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockedConnection.on.mockImplementation(function (event, handler) {
                        if (event === message_event_channel_1.MC_EVENTS.CONNECTED) {
                            handler();
                        }
                    });
                    mockedConnection.request.mockReturnValue({});
                    ExtensionFactory_1.extensionFactory.mockImplementation(function () {
                        throw new Error(Errors_1.EXTENSION.UNSUPPORTED_EXTENSION);
                    });
                    return [4 /*yield*/, expect(init_1.init()).rejects.toThrowErrorMatchingInlineSnapshot("\"Unsupported extension\"")];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should resolve the extension from the extensionFactory()', function () { return __awaiter(void 0, void 0, void 0, function () {
        var fakeContext;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockedConnection.on.mockImplementation(function (event, handler) {
                        if (event === message_event_channel_1.MC_EVENTS.CONNECTED) {
                            handler();
                        }
                    });
                    fakeContext = { params: { instance: {}, installation: {} } };
                    mockedConnection.request.mockReturnValue(fakeContext);
                    ExtensionFactory_1.extensionFactory.mockReturnValue({});
                    return [4 /*yield*/, expect(init_1.init()).resolves.toEqual({})];
                case 1:
                    _a.sent();
                    expect(ExtensionFactory_1.extensionFactory).toBeCalledWith(fakeContext, {
                        connection: mockedConnection,
                        window: window,
                        connectionTimeout: false,
                        timeout: false,
                        debug: false,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=Init.spec.js.map